"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.catchAsync = void 0;
const sNextGenerator_js_1 = __importDefault(require("./sNextGenerator.js"));
const catchAsync = (middleware, errorHandler) => (req, res, next) => {
    let consumersNext;
    if (errorHandler)
        consumersNext = (0, sNextGenerator_js_1.default)(errorHandler, req, res, next);
    else
        consumersNext = next;
    return Promise.resolve(middleware(req, res, consumersNext)).catch((error) => __awaiter(void 0, void 0, void 0, function* () { return !errorHandler ? next(error) : yield consumersNext(error); }));
};
exports.catchAsync = catchAsync;
exports.default = exports.catchAsync;
